#include "TBuffer.h"
#include "TClass.h"

#include <iostream>

void ContainedClassStreamer(TBuffer &buf, void *geoParam) { std::cout << "ContainedClassStreamer" << std::endl; }

// Proxy class for automatic registration of streamer function
class ContainedClassStreamerProxy {
public:
  ContainedClassStreamerProxy() {
    auto *tClass = TClass::GetClass("ContainedClass");
    if (tClass) {
      std::cout << "Register custom streamer for ContainedClass" << std::endl;
      tClass->SetStreamerFunc(ContainedClassStreamer);
    } else {
      throw(std::runtime_error("Dictionary for ContainedClass is not available"));
    }
  }
};

// Proxy object for automatic registration of streamer function
ContainedClassStreamerProxy containedClassStreamerProxy;
